Don't try to save os=nil in the fact importer

12/07/2012 11:06 AM - Greg Sutcliffe

Status: Closed   

Priority: Normal   

Assignee: Ohad Levy   

Category: Facts   

Target version: 1.1   

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases:  

Bugzilla link:  Red Hat JIRA:  

Pull request:    

Description

(Was "Puppet run in Finish Template wipes Operating System field in DB")

It's possible to hit an edge case where the os field comes in as nil and we try to save a new OS with name=NULL to the DB, which

fails validation. We should make that more defensive.

Associated revisions

Revision a3d09f07 - 12/19/2012 07:12 AM - Dominic Cleal

refs #2023 - always write using_storeconfigs default as a boolean

Revision 10130849 - 12/19/2012 07:12 AM - Ohad Levy

fixes #2023 - Don't try to save os=nil in the fact importer

I've tried to address all possible places where empty set of facts (e.g. we

dont have the facts just yet as its a brand new install) could lead to the

operating system value disappering.

i believe the issue happened because of a boolean == string compareing (e.g.

some left overs in cache might lead to if "false" which is true.

I've also ensured that we get an exception if the operating system value is empty

or if it does not pass validations.

History

#1 - 12/07/2012 02:37 PM - Ohad Levy

turn on sql debug and check the audit log too?

#2 - 12/08/2012 11:02 PM - Greg Sutcliffe

The audit log definitely shows the OS being wiped. I turned on fulldebug, but it was so noisy I couldn't see anything useful. I'll try and get a full log

pastie up tomorrow.

#3 - 12/09/2012 06:43 AM - Ohad Levy

- Priority changed from Urgent to Normal

I can't reproduce this, WFM

#4 - 12/09/2012 06:43 AM - Ohad Levy

- Assignee set to Greg Sutcliffe

#5 - 12/09/2012 08:12 AM - Greg Sutcliffe

- File clean.log added

Log attached. This seems easily repeatable for me - set a host to "Build" and run Puppet - OS disappears. You can see a rollback/audit happening in
the report processing section.

#6 - 12/09/2012 08:57 AM - Greg Sutcliffe

- Subject changed from Puppet run in Finish Template wipes Operating System field in DB to Don't try to save os=nil in the fact importer

- Category changed from Host creation to Facts

- Assignee deleted (Greg Sutcliffe)

- Priority changed from Normal to Low

- Target version deleted (1.1)

#7 - 12/09/2012 08:58 AM - Ohad Levy

- Target version set to 1.1

its not a nil os, rather a os with a nil name.

#8 - 12/19/2012 04:30 AM - Ohad Levy

- Status changed from New to Ready For Testing

- Assignee set to Ohad Levy

- Priority changed from Low to Normal

- % Done changed from 0 to 90

https://github.com/theforeman/foreman/pull/318

#9 - 12/19/2012 07:28 AM - Ohad Levy

- Status changed from Ready For Testing to Closed

- % Done changed from 90 to 100

Applied in changeset 10130849364f5184e3b0dcbae6cd6b4085ec1c84.

Files

clean.log 23.2 KB 12/09/2012 Greg Sutcliffe
